[leetcode] 【数组】18. 4Sum

Given an array S of n integers, are there elements a, b, c, and d in S such that a + b + c + d = target? Find all unique quadruplets in the array which gives the sum of target.

Note:
Elements in a quadruplet (a,b,c,d) must be in non-descending order. (ie, a ≤ b ≤ c ≤ d)
The solution set must not contain duplicate quadruplets.
For example, given array S = {1 0 -1 0 -2 2}, and target = 0.

A solution set is:
(-1,  0, 0, 1)
(-2, -1, 1, 2)
(-2,  0, 0, 2)

题解

在数组中找到所有4个元素的组合,组合之和为target。组合按顺序排好,并且不能重复。
a遍历4遍
b排序+夹逼
因为是4个元素,所以先存储所有2个元素组成的组合。
存储方法有两种:

unordered_multimap

可以用multimap存储重复的key,不同的pair。
这里介绍equal_range来遍历同一个key的所有pair:

unordered_multimap<int,pair<int,int> >>
auto range = cache.equal_range(key);
for (auto j = range.first; j != range.second; ++j) 

nordered_multimap
同一个key,一系列pair。
这里遍历所有pair就简单了,

unordered_map<int,vector<pair<int,int> > >
auto point2=cache.find(key);
for(int i=0;i!=point2->second.size();i++)

最后需要注意的就是防止重复的操作出现,要不然容易超时。
我的代码里有两个地方做了重复过滤,读者请自行理解为何需要过滤。

//cpp
class Solution {
public:
    vector<vector<int>> fourSum(vector<int>& nums, int target) {
        vector<vector<int> > res;
        if(nums.size()<4)
            return res;
        sort(nums.begin(),nums.end());
        unordered_map<int,vector<pair<int,int> > > cache;//记录每种组合
        for(int i=0;i!=nums.size();)
        {
            for(int j=i+1;j!=nums.size();)
            {
                cache[nums[i]+nums[j]].push_back(make_pair(nums[i],nums[j]));
                j++;
                while(nums[j-1]==nums[j]&&j!=nums.size()) j++;
            }
            i++;
            while(nums[i-1]==nums[i]&&i!=nums.size()) i++;
        }
        unordered_map<int,int> count;//记录每个数出现的次数
        for(int i=0;i!=nums.size();i++)
            count[nums[i]]++;
        for(auto point1 = cache.begin(); point1 != cache.end(); ++point1)
        {
            int key=target-point1->first;
            auto point2=cache.find(key);
            if(point2!=cache.end())
            {
                if(point1->first > point2->first) continue;//重复过滤
                for(int i=0;i!=point1->second.size();i++)//第一组大小的每种组合
                {
                    for(int j=0;j!=point2->second.size();j++)//第二组大小的每种组合
                    {
                        auto a=point1->second[i].first;
                        auto b=point1->second[i].second;
                        auto c=point2->second[j].first;
                        auto d=point2->second[j].second;
                        if(max(a,b)<=min(c,d)) //重复过滤
                        {
                            count[a]--;
                            count[b]--;
                            count[c]--;
                            count[d]--;
                            if(count[a]>=0&&count[b]>=0&&count[c]>=0&&count[d]>=0)//当两种组合一样时,这样可进行区分是否合法
                            {
                                vector<int> temp={a,b,c,d};
                                sort(temp.begin(),temp.end());
                                res.push_back(temp);
                            }
                            count[a]++;
                            count[b]++;
                            count[c]++;
                            count[d]++;
                        }
                    }
                }
            }
        }
        return res;
    }
};
  • 1
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论
给定一个整数数组 nums 和一个目标值 target,要求在数组中找出两个数的和等于目标值,并返回这两个数的索引。 思路1:暴力法 最简单的思路是使用两层循环遍历数组的所有组合,判断两个数的和是否等于目标值。如果等于目标值,则返回这两个数的索引。 此方法的时间复杂度为O(n^2),空间复杂度为O(1)。 思路2:哈希表 为了优化时间复杂度,可以使用哈希表来存储数组中的元素和对应的索引。遍历数组,对于每个元素nums[i],我们可以通过计算target - nums[i]的值,查找哈希表中是否存在这个差值。 如果存在,则说明找到了两个数的和等于目标值,返回它们的索引。如果不存在,将当前元素nums[i]和它的索引存入哈希表中。 此方法的时间复杂度为O(n),空间复杂度为O(n)。 思路3:双指针 如果数组已经排序,可以使用双指针的方法来求解。假设数组从小到大排序,定义左指针left指向数组的第一个元素,右指针right指向数组的最后一个元素。 如果当前两个指针指向的数的和等于目标值,则返回它们的索引。如果和小于目标值,则将左指针右移一位,使得和增大;如果和大于目标值,则将右指针左移一位,使得和减小。 继续移动指针,直到找到两个数的和等于目标值或者左指针超过了右指针。 此方法的时间复杂度为O(nlogn),空间复杂度为O(1)。 以上三种方法都可以解决问题,选择合适的方法取决于具体的应用场景和要求。如果数组规模较小并且不需要考虑额外的空间使用,则暴力法是最简单的方法。如果数组较大或者需要优化时间复杂度,则哈希表或双指针方法更合适。
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值